unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,
  LCLTMSFNCGrid, LCLTMSFNCSpinEdit, LCLTMSFNCGraphicsTypes,
  LCLTMSFNCPDFLib, LCLTMSFNCTypes, LCLTMSFNCPDFCoreLibBase;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TMSFNCGrid1: TTMSFNCGrid;
    TMSFNCSpinEdit1: TTMSFNCSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    function Calculate(var acol2, acol3: Single): Single;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

const
  products: String = 'Ocean Blue Shirt,Classic Varsity Top,Yellow Wool Jumper,Floral White Top,Striped Silk Blouse,Classic Leather Jacket,' +
    'Dark Denim Top,Navy Sports Jacket,Soft Winter Jacket,Black Leather Bag,Zipped Jacket,Silk Summer Top,Long Sleeve Cotton Top,' +
    'Chequered Red Shirt,White Cotton Shirt,Olive Green Jacket,Blue Silk Tuxedo,Red Sports Tee,Striped Skirt and Top,LED High Tops,' +
    'Clay Plant Pot,Copper Light,Cream Sofa,Antique Drawers,White Bed Clothes,Pink Armchair,Wooden Outdoor Table,Brown Throw Pillows,' +
    'White Ceramic Pot,Yellow watering can,Gardening hand trowel,Biodegradable cardboard pots,Grey Sofa,Wooden outdoor slats,Wooden Fence,' +
    'Yellow Sofa,Knitted Throw Pillows,Vanilla candle,Black Beanbag,Bedside Table';

var
  colmargin: Single = 5;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
  sl: TStringList;
begin
  Randomize;
  //grid
  TMSFNCGrid1.Columns.Clear;
  TMSFNCGrid1.Columns.Add;
  TMSFNCGrid1.Columns[0].Width := 40;
  TMSFNCGrid1.Columns[0].HorzAlignment := gtaTrailing;
  TMSFNCGrid1.Cells[0, 0] := 'ID';
  TMSFNCGrid1.Columns.Add;
  TMSFNCGrid1.Columns[1].Width := 300;
  TMSFNCGrid1.Columns[0].HorzAlignment := gtaLeading;
  TMSFNCGrid1.Cells[1, 0] := 'Name';
  TMSFNCGrid1.Columns.Add;
  TMSFNCGrid1.Columns[2].Width := 80;
  TMSFNCGrid1.Columns[2].HorzAlignment := gtaTrailing;
  TMSFNCGrid1.Cells[2, 0] := 'Qty';
  TMSFNCGrid1.Columns.Add;
  TMSFNCGrid1.Columns[3].Width := 100;
  TMSFNCGrid1.Columns[3].HorzAlignment := gtaTrailing;
  TMSFNCGrid1.Cells[3, 0] := 'Price';
  TMSFNCGrid1.RowCount := Random(200) + 51;
  //data
  sl := TStringList.Create;
  sl.StrictDelimiter := True;
  sl.Delimiter := ',';
  sl.DelimitedText := products;
  for i := 1 to TMSFNCGrid1.RowCount do
  begin
    TMSFNCGrid1.Cells[0, i] := IntToStr(i);
    TMSFNCGrid1.Cells[1, i] := sl[Random(sl.Count)];
    TMSFNCGrid1.Cells[2, i] := IntToStr(Random(12) + Random(i));
    TMSFNCGrid1.Cells[3, i] := FormatFloat('0.00', (Random(200) + 10) / (Random(5) + 1));
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  pdf: TTMSFNCPDFLib;
  y, rowheight, col1, col1width, col2, col3: Single;
  tr, rect: TRectF;
  i: Integer;
  s: String;
begin
  y := 0;
  col1 := 0;  
  col1width := 0;
  col2 := 0;
  col3 := 0;
  //document settings
  pdf := TTMSFNCPDFLib.Create;
  pdf.EmbedFonts := True;
  pdf.Title := 'Purchase order';
  pdf.Author := 'Author';
  pdf.Creator := 'Lazarus';
  pdf.Subject := 'Purchase order';
  pdf.BeginDocument('fncpdf-test.pdf');
  pdf.PageSize := psCustom;
  pdf.PageWidth := MillimeterToPixel(TMSFNCSpinEdit1.Value);
  pdf.PageHeight := Calculate(col2, col3);
  //columns
  col1 := colmargin;
  col1width := pdf.PageWidth - col2 - col3 - 4 * colmargin;
  col2 := pdf.PageWidth - col3 - 2 * colmargin;
  col3 := pdf.PageWidth - colmargin;
  //
  pdf.PageOrientation := poPortrait;
  pdf.Header := '';
  pdf.HeaderSize := 0;
  pdf.Footer := '';
  pdf.FooterSize := 0;
  //new page
  pdf.NewPage;
  pdf.Graphics.Font.Name := 'Lato';
  pdf.Graphics.Fill.Color := gcNull;
  //header
  if Edit1.Text <> '' then
  begin
    pdf.Graphics.Alignment := gtaCenter;
    pdf.Graphics.Font.Size := 8;
    pdf.Graphics.Font.Style := [fsBold];
    s := Edit1.Text;
    tr := RectF(0, 0, pdf.PageWidth, 500);
    tr := pdf.Graphics.CalculateText(s, tr);
    rect.Left := 0;
    rect.Top := y;
    rect.Width := pdf.PageWidth;
    rect.Height := tr.Height;
    pdf.Graphics.DrawText(s, rect);
    y := y + tr.Height + 2;
    pdf.Graphics.Stroke.Color := clBlack;
    pdf.Graphics.Stroke.Kind := gskSolid;
    pdf.Graphics.Stroke.Width := 2;
    pdf.Graphics.DrawLine(PointF(2, y), PointF(pdf.PageWidth - 2, y));
  end;
  y := y + 10;
  pdf.Graphics.Alignment := gtaLeading;
  //items header
  pdf.Graphics.Font.Size := 6;
  pdf.Graphics.Font.Style := [fsBold];
  pdf.Graphics.Font.Color := gcBlack;
  s := 'Name';
  tr := pdf.Graphics.CalculateText(s);
  pdf.Graphics.DrawText(s, PointF(col1, y));
  s := 'Qty';
  tr := pdf.Graphics.CalculateText(s);
  pdf.Graphics.DrawText(s, PointF(col2 - tr.Width, y));
  rowheight := tr.Height;
  s := 'Price';
  tr := pdf.Graphics.CalculateText(s);
  pdf.Graphics.DrawText(s, PointF(col3 - tr.Width, y));
  y := y + rowheight + 5;
  //items
  pdf.Graphics.Font.Style := [];
  for i := 1 to TMSFNCGrid1.RowCount - 1 do
  begin
    if i mod 2 = 0 then
      pdf.Graphics.Font.Color := gcBlack
    else
      pdf.Graphics.Font.Color := gcGray;
    s := TMSFNCGrid1.Cells[1, i];
    tr := RectF(0, 0, col1width, 500);
    tr := pdf.Graphics.CalculateText(s, tr);
    rect.Left := col1;
    rect.Top := y;
    if tr.Width <= col1width then
      rect.Width := col1width
    else
      rect.Width := tr.Width;
    rect.Height := tr.Height;
    pdf.Graphics.DrawText(s, rect);
    rowheight := tr.Height;
    s := TMSFNCGrid1.Cells[2, i];
    tr := pdf.Graphics.CalculateText(s);
    pdf.Graphics.DrawText(s, PointF(col2 - tr.Width, y));
    s := '$' + TMSFNCGrid1.Cells[3, i];
    tr := pdf.Graphics.CalculateText(s);
    pdf.Graphics.DrawText(s, PointF(col3 - tr.Width, y));
    y := y + rowheight + 1;
  end;
  //footer
  if Edit2.Text <> '' then
  begin
    pdf.Graphics.Font.Color := gcBlack;
    pdf.Graphics.Alignment := gtaCenter;
    pdf.Graphics.Font.Size := 8;
    pdf.Graphics.Font.Style := [fsBold];
    s := Edit2.Text;
    tr := RectF(0, 0, pdf.PageWidth, 500);
    tr := pdf.Graphics.CalculateText(s, tr);
    rect.Left := 0;
    rect.Top := pdf.PageHeight - tr.Height;
    rect.Width := pdf.PageWidth;
    rect.Height := tr.Height;
    y := pdf.PageHeight;
    y := y - tr.Height - 5;
    pdf.Graphics.Stroke.Color := clBlack;
    pdf.Graphics.Stroke.Kind := gskSolid;
    pdf.Graphics.Stroke.Width := 2;
    pdf.Graphics.DrawLine(PointF(2, y), PointF(pdf.PageWidth - 2, y));
    y := y + 2;
    pdf.Graphics.DrawText(s, rect);
  end;
  //end of document
  pdf.EndDocument(True);
  pdf.Free;
end;

function TForm1.Calculate(var acol2, acol3: Single): Single;
var
  pdf: TTMSFNCPDFLib;
  col1width, col2, col3: Single;
  tr: TRectF;
  i: Integer;
  s: String;
begin
  Result := 0;
  col1width := 0;
  col2 := 0;
  col3 := 0;
  //document settings
  pdf := TTMSFNCPDFLib.Create;
  pdf.BeginDocument;
  pdf.PageSize := psCustom;
  pdf.PageHeight := MillimeterToPixel(10000);
  pdf.PageWidth := MillimeterToPixel(TMSFNCSpinEdit1.Value);
  pdf.PageOrientation := poPortrait;
  pdf.Header := '';
  pdf.HeaderSize := 0;
  pdf.Footer := '';
  pdf.FooterSize := 0;
  //new page
  pdf.NewPage;
  pdf.Graphics.Font.Name := 'Lato';
  //header
  if Edit1.Text <> '' then
  begin
    pdf.Graphics.Alignment := gtaCenter;
    pdf.Graphics.Font.Size := 8;
    pdf.Graphics.Font.Style := [fsBold];
    s := Edit1.Text;
    tr := RectF(0, 0, pdf.PageWidth, 500);
    tr := pdf.Graphics.CalculateText(s, tr);
    Result := Result + tr.Height + 5;
  end;
  Result := Result + 5;
  pdf.Graphics.Alignment := gtaLeading;
  //items header
  pdf.Graphics.Font.Size := 6;
  pdf.Graphics.Font.Style := [fsBold];
  s := 'Qty';
  tr := pdf.Graphics.CalculateText(s);
  Result := Result + tr.Height + 5;
  //items
  pdf.Graphics.Font.Style := [];
  //col2 width
  for i := 1 to TMSFNCGrid1.RowCount - 1 do
  begin
    s := TMSFNCGrid1.Cells[2, i];
    tr := pdf.Graphics.CalculateText(s, tr);
    if col2 < tr.Width then
      col2 := tr.Width;
  end;
  col2 := col2 + 5;
  //col3 width
  for i := 1 to TMSFNCGrid1.RowCount - 1 do
  begin
    s := '$' + TMSFNCGrid1.Cells[3, i];
    tr := pdf.Graphics.CalculateText(s, tr);
    if col3 < tr.Width then
      col3 := tr.Width;
  end;
  col3 := col3 + 5;
  //columns
  col1width := pdf.PageWidth - col2 - col3 - 4 * colmargin;
  acol2 := col2;
  acol3 := col3;
  //
  for i := 1 to TMSFNCGrid1.RowCount - 1 do
  begin
    s := TMSFNCGrid1.Cells[1, i];
    tr := RectF(0, 0, col1width, 200);
    tr := pdf.Graphics.CalculateText(s, tr);
    Result := Result + tr.Height + 1;
  end;
  Result := Result + 20;
  //footer
  if Edit2.Text <> '' then
  begin
    pdf.Graphics.Alignment := gtaCenter;
    pdf.Graphics.Font.Size := 8;
    pdf.Graphics.Font.Style := [fsBold];
    Result := Result + 6;
    s := Edit2.Text;
    tr := pdf.Graphics.CalculateText(s);
    Result := Result + tr.Height;
  end;
  //end of document
  pdf.EndDocument;
  pdf.Free;
end;

end.
